% 2d finite difference transform matrix: matrix vector multiplication
%
% (c) by Hannes Nickisch, MPI for Biological Cybernetics, 2010 July 15

function y = mtimes(A,x)
  if A.ctransp
    x = reshape(x,[A.imsz,2]);
    y =   [-x(1,:,1); x(1:end-2,:,1)-x(2:end-1,:,1); x(end-1,:,1)] ...
        + [-x(:,1,2), x(:,1:end-2,2)-x(:,2:end-1,2), x(:,end-1,2)];
    
  else
    x = reshape(x,A.imsz);
    y = cat(3, x([2:end,end],:)-x, x(:,[2:end,end])-x);
  end
  y = y(:);