% 2d partial FFT matrix selecting rows: matrix vector multiplication
%
% (c) by Hannes Nickisch, MPI for Biological Cybernetics, 2010 July 15

function y = mtimes(A,x)

  if A.ctransp
    y = zeros(A.imsz);
    y(A.id,:) = reshape(x,[numel(A.id),A.imsz(2)]);
    y = ifft2(ifftshift(y))*sqrt(prod(A.imsz));
    if ~A.complex, y = real(y); end
  else
    x = reshape(x,A.imsz);
    if ~A.complex, x = real(x); end
    y = fftshift( fft2(x)/sqrt(prod(A.imsz)) );
    y = y(A.id,:);
  end
  y = y(:);