% A penalty function pen(s) is a scalar function IR -> IR.
%
%   [p,dp,d2p] = pen(s,psi) where psi contains additional parameters
%
% The return arguments are of the same size as s and have the following meaning:
%   p   =     pen(s),
%   dp  = d   pen(s) / ds, and
%   d2p = d^2 pen(s) / ds^2.
% 
% Currently, we have implemented in pen/pen<NAME>.m
%   Logarithmic:            penLog(s,nu)            = log(s^2+nu),
%   Power:                  penPow(s,d)             = abs(s)^d,
%   Quadratic:              penQuad(s)              = s^2/2,
%   Zero:                   penZero(s)              = 0, and
%   Derived from potential: penFromPot(s,pot,tau,z) = ...
%                          tau*b*(r-s) -log( pot(tau*r) ), r=sign(s)*sqrt(s^2+z)
%
% Examples:
% >>  s=0.3; d=1.5; penPow(s,d)
% >>  s=-4;  pot='potLaplace'; tau=2; z=1.3; penFromPot(s,pot,tau,z)
%
%   See also POTFUNCTIONS.M.
%
% (c) by Hannes Nickisch, MPI for Biological Cybernetics, 2010 August 09